;TIP1221.LSP:     PURGE.LSP     Automated Purge for R12     (c)1996, Pavel Trebukov

;; Files XYZPURGE.SCR and XYZPURGE are used by this routine.
;;
;; Add to ACADR12.LSP for automatic loading:
;;    (defun c:prge () (load "[drive]:/[path]/prge") (c:prge)) 

(defun *error* (MSG) (princ MSG) (princ))
(defun err1 (MSG) 
  (command "undo" 1)
  (command "files" 3 (strcat PRF "xyzpurge.*") "Y" "Y" "" "")  
  (princ MSG) (princ)
) ;end err1
(defun err2 (MSG) (command "undo" 1) (princ MSG) (princ)) 
(defun err3 (MSG) 
  (command "files" 3 (strcat PRF "xyzpurge.*") "Y" "Y" "" "")  
  (princ MSG) (princ)
) ;end err3

(defun aprg ()                ;;automatic purge command
  (command "purge" KW)
  (while (/= 0 (getvar "cmdactive")) (command "y")) 
) ;end aprg

(defun scf (PR1)
  ;;----------------------script file xyzpurge.scr
  (setq FL1 (open (strcat PRF "xyzpurge.scr") "w"))
  (write-line "save" FL1) (write-line "" FL1)
  (write-line "open" FL1) (write-line "" FL1)
  (write-line "prge" FL1)
  (setq FL1 (close FL1))   
  ;;----------------------file xyzpurge
  (setq FL2 (open (strcat PRF "xyzpurge") "w"))
  (write-line KW FL2)                       ;save KW
  (if (= PR1 "TT") (write-line PR1 FL2))    ;save PR1
  (setq FL2 (close FL2))   
  (command "script" (strcat PRF "xyzpurge.scr"))
) ;end scf

(defun prgs ()
  (setq OLDERROR *error*   NST "No")
  (initget "Blocks Dimstyles LAyers LTypes SHapes STyles All")
  (setq KW (getkword "\nAutomatic Purge: 
      Blocks/Dimstyles/LAyers/LTypes/SHapes/STyles/<All>: "))
      (if (= KW nil) (setq KW "All")) ;end if
      (if (member KW (list "Blocks" "All"))
        (progn
          (initget "Yes No")
          (setq NST (getkword "\nPurge nested ?  No/<Yes>: "))   
        ) ;end progn
      ) ;end if
      ;;DBMOD = 20 - ZOOM or PAN commands
      (if (or (= NST nil) (= NST "Yes"))
        (if (member (getvar "DBMOD") (list 0 20))
          (progn
            (setq *error* ERR2)  
            (aprg)
            (setq *error* ERR1)  
            (scf "TT")
          ) ;end progn
          (progn (setq *error* ERR3) (scf "TT")) ;end progn
        ) ;end if (dbmod)
        ;;-----------------------(/= NST "Yes")
        (if (member (getvar "dbmod") (list 0 20))
          (progn
            (setq *error* ERR2) 
            (aprg)
            (setq *error* OLDERROR)  (princ)
          ) ;end progn
          (progn (setq *error* ERR3)  (scf nil)) ;end progn
        ) ;end if (dbmod)
      ) ;end if (= NST "yes")
    ) ;end prgs

    (defun C:PRGE ()
      (setvar "CMDECHO" 0)
      (cond
        ((= (getvar "dwgname") "UNNAMED")  
          (alert "Drawing is UNNAMED !!!")
        )
        (t  (setq PRF (getvar "dwgprefix") 
            FF1 (findfile (strcat PRF "xyzpurge.scr"))
          FF2 (findfile (strcat PRF "xyzpurge")))
          (if (not (or FF1 FF2))
            (prgs)
            (progn
              (setq OLDERROR *error*  *error* ERR1)
              (setq FL2 (open (strcat PRF "xyzpurge") "r")   ;restore 
                KW (read-line FL2)  PR1 (read-line FL2)  ;KW and PR1
              FL2 (close FL2))
              (aprg)
              (if (and (= PR1 "TT") (/= 0 (getvar "dbmod"))) 
                (command "script" (strcat PRF "xyzpurge.scr"))
                (command "files" 3 (strcat PRF "xyzpurge.*") "Y" "Y" "" "")    
              ) ;end if (= PR1 "tt")
              (setq *error* OLDERROR)  (princ)
            ) ;end progn
          ) ;end if (FF1 FF2)
        ) ;end (t)
      ) ;end cond
    ) ;end prge 
    (princ);end prge.lsp
