;TIP1223.LSP:     XLIST.LSP     List an Xref Entity  $50 BONUS WINNER    (c)1996, Daryl L. Monk

(defun dxf (CODE E_LIST)
  (cdr (assoc CODE E_LIST))
)

(defun C:XLIST ( / E EN ED NAME VJUST HJUST WDTH NAME ELAY ECLR ELIN 
    STPT ENPT CTRPT RAD ROT TXHT VAL OBLQ JUSTNAM LAYDAT
  LAYCLR LAYLTYP STYL SBLIP)
  (setq SBLIP (getvar "BLIPMODE"))

  ;GET OBJECT(s)
  (setq E (nentsel
  "\nSelect XRef Object, then <return> to list: "))

  ;Loop until a return entered at selection prompt
  (while e

    ;Get entity data
    (setq EN (car E) ED (entget EN))

    ;Determine name of entity
    (setq NAME (dxf 0 ED)  ELAY (dxf 8 ED) 
      ECLR (dxf 62 ED) ELIN (dxf 6 ED)
    )
    (getstring)

    ;Get values depending on object name
    (cond
      ((= NAME "LINE") 
        (setq STPT (dxf 10 ED) ENPT (dxf 11 ED))
      )
      ((or (= NAME "CIRCLE") (= NAME "ARC"))
        (setq CTRPT (dxf 10 ED) RAD (dxf 40 ED))
      )
      ((= NAME "TEXT")
        (setq STPT (dxf 10 ED)  STYL (dxf 7 ED) HJUST (dxf 72 ED) 
          VJUST (dxf 73 ED) ROT (dxf 50 ED) TXHT (dxf 40 ED) 
          WDTH (dxf 41 ED)  VAL (dxf 1 ED)  OBLQ (dxf 51 ED)
        )
        (cond
          ((= HJUST 0) (setq JUSTNAM "Left"))
          ((= HJUST 1) (setq JUSTNAM "Center"))
          ((= HJUST 2) (setq JUSTNAM "Right"))
          ((= HJUST 3) (setq JUSTNAM "Aligned"))
          ((= HJUST 4) (setq JUSTNAM "Middle"))
          ((= HJUST 5) (setq JUSTNAM "Fit"))
        )
        (if (< Hjust 3)
          (cond
            ((= VJUST 3) (setq JUSTNAM (strcat "T" JUSTNAM)))
            ((= VJUST 2) (setq JUSTNAM (strcat "M" JUSTNAM)))
            ((= VJUST 1) (setq JUSTNAM (strcat "B" JUSTNAM)))
          )
        );if
      );cond
      (if (/= HJUST 0) (setq STPT (dxf 11 ED)))
    );cond

    ;Trap for bylayer
    ;Color bylayer
    (if (not ECLR) 
      (progn
        (setq LAYDAT (tblsearch "LAYER" ELAY)
          LAYCLR (dxf 62 LAYDAT)
          ECLR (strcat "Bylayer: " (itoa LAYCLR))
        )
      )
      (setq ECLR (itoa ECLR))
    );endif

    ;Linetype bylayer
    (if (not ELIN) 
      (setq LAYDAT (tblsearch "LAYER" ELAY)
        LAYLTYP (dxf 6 LAYDAT)
        ELIN (strcat "Bylayer: " LAYLTYP)
      )
    );endif

    ;Print results
    ;General entity
    (princ (strcat "\n\n >>Xlist of Object: " NAME))
    (if STYL (princ (strcat "\n    Value: " VAL)))
    (princ (strcat "\n    Layer: " ELAY 
        "\n    Color: " ECLR 
    "\n    Linetype: " ELIN))

    ;Start point
    (if STPT 
      (progn
        (princ (strcat "\n    Start pt: "))
        (princ STPT)
      )
    );if

    ;End point
    (if ENPT 
      (progn 
        (princ (strcat "\n    End pt: "))
        (princ ENPT)
      )
    );if

    ;Text
    (if STYL 
      (princ 
        (strcat "\n    Height: " (rtos TXHT) "\tWidth: " (rtos WDTH 2 2) 
          "\tText Angle: " (angtos ROT) 
          "\n    Justify: " justnam "\tText Style: " STYL 
          "\tOblique Angle: " (angtos OBLQ)
        )
      )
    );endif

    ;Circle or arc
    (if ctrpt 
      (progn
        (princ (strcat "\n    Center pt: " ))
        (princ ctrpt)
        (princ (strcat "\tRadius: " (rtos rad)))
      )
    );endif

    ;Reset variables
    (setq STPT nil ENPT nil STYL nil TXHT nil ROT nil RAD nil CTRPT nil NAME nil VAL nil)

    ;Get next selection
    (setq E (nentsel 
    "\n\nSelect another (then <return> to list) or just <return> to exit: "))
  )

  (setvar "BLIPMODE" SBLIP)
  (prin1)
); end xist.lsp
